world = class:new()

function world:init( bgx,bgy ) 
	-- This is the effective combined block size of the world
	self.blockGridXSize = bgx
	self.blockGridYSize = bgy 
	-- Each block Width & Height
	self.blockSize = 16

	-- all the world blocks
	worldBlocks = {}
	love.graphics.setBackgroundColor(82,198,233)

	
end


function world:update()
	timeBefore = love.timer.getTime()
	blockSetBatch:clear()
	for i=1, #worldBlocks do
		if worldBlocks[i].x * self.blockSize >= PlayerCam.x and worldBlocks[i].x * self.blockSize < love.graphics.getWidth() 
			and worldBlocks[i].y * self.blockSize >= PlayerCam.y and worldBlocks[i].y * self.blockSize < love.graphics.getHeight() then   
			blockSetBatch:addq( worldBlocks[i].id.img, worldBlocks[i].x * self.blockSize, worldBlocks[i].y * self.blockSize )
		end 
	end
	howLongItTookToExecute = love.timer.getTime() - timeBefore 
end 

function world:draw()
	love.graphics.draw(blockSetBatch)
end

function world:randomSeedMap()
	local blockx = 0 - self.blockSize
	local blocky = 0 - self.blockSize
	local blockNo = self.blockGridXSize * self.blockGridYSize
	local cblock = 0
	local baseHeightX,baseHeightY = BlockGridRef( 0,0,self.blockSize) --BlockGridRef( 0,math.random(self.blockGridYSize/2, self.blockGridYSize/2 + 10),self.blockSize)
	local belowBaseStart = baseHeightY + self.blockSize
	Elevations = {}
	Caves = {}
	

	for i=1, blockNo do 
		blockx = blockx + self.blockSize
		if blockx > self.blockGridXSize * self.blockSize then
		blockx = 0
		blocky = blocky + self.blockSize 
		end 
		-- This will draw in the base height level of the map
		if blockx == baseHeightX and blocky == baseHeightY then
			cblock = 1
			repeat 
				BlockSpawn( blockx,blocky,SelectBlock(cblock),cblock,self.blockSize )
				blockx = blockx + self.blockSize
			until blockx >= self.blockGridXSize * self.blockSize 
		end 
		
		if blockx == 0 and blocky >= belowBaseStart then
			cblock = 2
			repeat 
				BlockSpawn( blockx,blocky,SelectBlock(cblock),cblock,self.blockSize )
				blockx = blockx + self.blockSize
			until blockx >= self.blockGridXSize * self.blockSize
			belowBaseStart = belowBaseStart + self.blockSize
			blockx = 0
		end 
		
	end 
end